; Source created with Parsic Version 3.x

; at              : 2009.04.15. 11:28:40


; Project File    : C:\DOCUME~1\RENDSZ~1\ASZTAL\TIMER\1x16\timer1.PIC

; Project Version : 1.0.50

; Created         : 2008.08.31. 10:28:00

; Last change     : 2009.04.15. 11:28:36

	PROCESSOR 16F628

	INCLUDE P16F628.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_OFF & _BODEN_ON & _XT_OSC & _LVP_OFF & _MCLRE_ON

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

S0	= 32	; located in Bank 0
S2	= 33	; located in Bank 0
OS1_FD	= 34	; located in Bank 0
OS2_FD	= 35	; located in Bank 0
S3	= 36	; located in Bank 0
S1	= 37	; located in Bank 0
ZV1	= 38	; located in Bank 0
ZV1_FD	= 39	; located in Bank 0
ZR1	= 40	; located in Bank 0
ZR1_FD	= 41	; located in Bank 0
S6	= 42	; located in Bank 0
S5	= 43	; located in Bank 0
OS3_FD	= 44	; located in Bank 0
ZV2	= 45	; located in Bank 0
ZV2_FD	= 46	; located in Bank 0
S4	= 47	; located in Bank 0
ZV3	= 48	; located in Bank 0
ZV3_FD	= 49	; located in Bank 0
OS4_FD	= 50	; located in Bank 0
OS5_FD	= 51	; located in Bank 0
LT1_FD	= 52	; located in Bank 0
LT2_FD	= 53	; located in Bank 0
LT3_FD	= 54	; located in Bank 0
LT4_FD	= 55	; located in Bank 0
LT5_FD	= 56	; located in Bank 0
LT6_FD	= 57	; located in Bank 0
TR1	= 58	; located in Bank 0
TR1_HI	= 59	; located in Bank 0
LT7_FD	= 60	; located in Bank 0
MF1	= 61	; located in Bank 0
MF1_HI	= 62	; located in Bank 0
MF1_FD	= 63	; located in Bank 0
TR2	= 64	; located in Bank 0
TR2_HI	= 65	; located in Bank 0
RAM	= 66	; located in Bank 0
SYS_TMP1	= 112	; located in Bank 0, 1, 2, 3
SYS_TMP2	= 113	; located in Bank 0, 1, 2, 3
SYS_TMP3	= 114	; located in Bank 0, 1, 2, 3
SYS_TMP4	= 115	; located in Bank 0, 1, 2, 3
SYS_TMP5	= 116	; located in Bank 0, 1, 2, 3
SYS_WSAV	= 117	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 118	; located in Bank 0, 1, 2, 3
SYS_TMP6	= 119	; located in Bank 0, 1, 2, 3
SYS_TMP9	= 120	; located in Bank 0, 1, 2, 3
SYS_TMP10	= 121	; located in Bank 0, 1, 2, 3
SYS_TMP7	= 122	; located in Bank 0, 1, 2, 3
SYS_TMP8	= 123	; located in Bank 0, 1, 2, 3
SYS_FSAV	= 124	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV
	MOVFW FSR
	MOVWF SYS_FSAV


	BTFSS INTCON,T0IF	; TMR0 ?
	GOTO NOTMR0INT
	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_1
	INCF MF1_HI,F

SYS_INT_LABEL_1
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_2
	INCF TR2_HI,F

SYS_INT_LABEL_2
NOTMR0INT


EXITINT

	MOVFW SYS_FSAV
	MOVWF FSR
	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE


;****************************************
; Subroutines
;****************************************

;****************************************
; Direct jump into a table
;****************************************

SYSTABJMP
	BCF INTCON,GIE
	BTFSC INTCON,GIE
	GOTO SYSTABJMP
	MOVFW SYS_TMP2
	MOVWF PCLATH
	MOVFW SYS_TMP1
	MOVWF PCL
;***************************************************
; Subroutines for LB1
;***************************************************

LCD_LB1_INIT
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
LCD_LB1_L1
	CALL LCD_LB1_OUT4
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L1

	MOVFW PORTB
	ANDLW H'F0'
	IORLW B'0011'	; Function Set
	MOVWF PORTB

	BSF PORTB,5	; write
	GOTO $+1
	BCF PORTB,5

	BSF SYS_TMP1,5	; wait
LCD_LB1_L2
	CALL LCD_LB1_OUT4
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L2

	BSF PORTB,5	; write
	GOTO $+1
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BSF PORTB,5	; write
	GOTO $+1
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BCF PORTB,0	; 4-Bit Interface

	BSF PORTB,5	; write
	GOTO $+1
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	MOVLW B'00101000'	; Function Set 4-Bit,2-Lines
	CALL LCD_LB1_OUT

	MOVLW B'00001100'	; Display on, Cursor off, Blink off
	CALL LCD_LB1_OUT

	MOVLW B'00000110'	; Entrymode set
	CALL LCD_LB1_OUT

LCD_LB1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW B'00000001'	; Display clear
	CALL LCD_LB1_OUT

	BSF SYS_TMP1,5	; wait
LCD_LB1_L3
	CALL LCD_LB1_OUT4
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L3
	GOTO LCD_LB1_OUT4

;***************************************************

LCD_LB1_GOTOXY
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW H'40'
	BTFSC SYS_TMP2,0	; Ypos
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1
	MOVWF SYS_TMP7
	BSF SYS_TMP1,7	; select dd-ram
	GOTO LCD_LB1_OUT1

;***************************************************

LCD_LB1_WRITESTR
LCD_LB1_WRITESTR1
	CALL LCD_LB1_CHAROUT
	BSF INTCON,GIE
	ANDLW H'FF'	; last is zero
	BTFSC STATUS,ZERO
	RETURN

	MOVWF SYS_TMP1
	MOVFW SYS_TMP1
	CALL LCD_LB1_WRITECHAR
	INCFSZ SYS_TMP4,F	; next char
	GOTO LCD_LB1_WRITESTR1
	INCF SYS_TMP5,F	; next page
	GOTO LCD_LB1_WRITESTR1

LCD_LB1_CHAROUT
	BCF INTCON,GIE
	MOVFW SYS_TMP5
	MOVWF PCLATH
	MOVFW SYS_TMP4
	MOVWF PCL

;***************************************************

LCD_LB1_DEZO10000

	MOVLW LOW 10000
	MOVWF SYS_TMP1
	MOVLW HIGH 10000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1000
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1000

	MOVLW LOW 1000
	MOVWF SYS_TMP1
	MOVLW HIGH 1000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO100
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO100

	MOVLW LOW 100
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO10
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO10

	MOVLW LOW 10
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1
	MOVLW 48
	ADDWF SYS_TMP4,W
	GOTO LCD_LB1_WRITECHAR

;***************************************************

LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	CLRF SYS_TMP6
LCD_LB1_CONVERTDEZ2
	INCF SYS_TMP6,F

	MOVFW SYS_TMP1
	SUBWF SYS_TMP4,F

	MOVFW SYS_TMP2
	BTFSS STATUS,CARRY
	INCFSZ SYS_TMP2,W
	SUBWF SYS_TMP5,F
	BTFSC STATUS,CARRY
	GOTO LCD_LB1_CONVERTDEZ2

	MOVFW SYS_TMP2
	ADDWF SYS_TMP5,F
	MOVFW SYS_TMP1
	ADDWF SYS_TMP4,F
	BTFSC STATUS,CARRY
	INCF SYS_TMP5,F

	DECF SYS_TMP6,W
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	RETURN

;***************************************************

LCD_LB1_CONVERTHEX
	ANDLW 15
	MOVWF SYS_TMP1
	MOVLW 48
	ADDWF SYS_TMP1,F
	MOVLW 58
	SUBWF SYS_TMP1,W
	BTFSS STATUS,CARRY
	GOTO $+3
	MOVLW 7
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1

;***************************************************

LCD_LB1_WRITECHAR
	MOVWF SYS_TMP8
	INCF SYS_TMP7,F
	MOVLW 9
	SUBWF SYS_TMP7,W
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_OUTZ1
	MOVLW 192	; set adress to 40h
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir
	CALL LCD_LB1_OUT
LCD_LB1_OUTZ1
	MOVFW SYS_TMP8
	BSF PORTB,4	; dd-ram

;***************************************************

LCD_LB1_OUT
	MOVWF SYS_TMP1	; store
LCD_LB1_OUT1
	CLRF SYS_TMP3	; LCDWriteStr (first nibble)
LCD_LB1_OUT2
	SWAPF SYS_TMP1,W	;high nibble
LCD_LB1_OUT3
	ANDLW H'0F'	; mask
	MOVWF SYS_TMP2	; store
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW PORTB	; load port
	ANDLW H'F0'	; mask
	IORWF SYS_TMP2,W	; add cmd
	MOVWF PORTB	; out

	BSF PORTB,5	; E high
	GOTO $+1
	BCF PORTB,5	; E low

	BTFSC SYS_TMP3,3	; ready ?
	GOTO LCD_LB1_OUT4	; yes
	BSF SYS_TMP3,3	; second nibble
	MOVFW SYS_TMP1
	GOTO LCD_LB1_OUT3	; next nibble

LCD_LB1_OUT4
LCD_LB1_OUTV
	DECFSZ SYS_TMP3,F
	GOTO LCD_LB1_OUTV
	RETURN

;***************************************************

LCD_LB1_CHECKNULL
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	MOVWF SYS_TMP1
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	MOVLW 48
	BTFSC SYS_TMP10,0
	ADDWF SYS_TMP1,f
	MOVLW 32
	BTFSS SYS_TMP10,0
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1
	GOTO LCD_LB1_WRITECHAR
; 00E6

;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Set output before direction

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

	BCF STATUS,RP0	; Bank 0
	MOVLW 7	; Comparators off
	MOVWF CMCON
; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'50'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3

	MOVLW B'00010000'
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF S0
	MOVLW B'00000001'
	MOVWF S2
	MOVLW B'10000000'
	MOVWF S1

;***************************************************
; Init LCD -> LB1
;***************************************************

	CALL LCD_LB1_INIT

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,5
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S1,4
	GOTO LABEL_LG1_FALSE
LABEL_LG1_3
	BTFSS S1,3
	GOTO LABEL_LG1_FALSE
LABEL_LG1_4
	BTFSS S1,2
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S0,5
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,5
LABEL_LG1_ENDE
;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS S2,5
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BTFSS S2,4
	GOTO LABEL_LG2_FALSE
LABEL_LG2_3
	BTFSS S2,3
	GOTO LABEL_LG2_FALSE
LABEL_LG2_4
	BTFSS S2,2
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF S2,6
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,6
LABEL_LG2_ENDE
;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSC PORTA,2
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,1
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,1
	BTFSS PORTA,2
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; One Shot -> OS2
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTA,1
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S0,3
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,3
	BTFSS PORTA,1
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; ODER - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S0,2
	GOTO LABEL_LG3_TRUE
LABEL_LG3_2
	BTFSC S0,5
	GOTO LABEL_LG3_TRUE

LABEL_LG3_FALSE
	BCF S3,0
	GOTO LABEL_LG3_ENDE
LABEL_LG3_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S3,0
LABEL_LG3_ENDE
;***************************************************
; ODER - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSC S1,1
	GOTO LABEL_LG4_TRUE
LABEL_LG4_2
	BTFSC S0,6
	GOTO LABEL_LG4_TRUE

LABEL_LG4_FALSE
	BCF S0,0
	GOTO LABEL_LG4_ENDE
LABEL_LG4_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S0,0
LABEL_LG4_ENDE
;***************************************************
; UND - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BTFSS S0,4
	GOTO LABEL_LG5_FALSE
LABEL_LG5_2
	BTFSS S0,3
	GOTO LABEL_LG5_FALSE

LABEL_LG5_TRUE
	BSF S0,2
	GOTO LABEL_LG5_ENDE
LABEL_LG5_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,2
LABEL_LG5_ENDE
;***************************************************
; UND - Gatter -> LG6
;***************************************************

LABEL_LG6_1
	BTFSS S0,4
	GOTO LABEL_LG6_FALSE
LABEL_LG6_2
	BTFSS S0,1
	GOTO LABEL_LG6_FALSE

LABEL_LG6_TRUE
	BSF S1,1
	GOTO LABEL_LG6_ENDE
LABEL_LG6_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,1
LABEL_LG6_ENDE
;***************************************************
; UND - Gatter -> LG7
;***************************************************

LABEL_LG7_1
	BTFSS S0,7
	GOTO LABEL_LG7_FALSE
LABEL_LG7_2
	BTFSS S1,0
	GOTO LABEL_LG7_FALSE

LABEL_LG7_TRUE
	BSF S0,6
	GOTO LABEL_LG7_ENDE
LABEL_LG7_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,6
LABEL_LG7_ENDE
;***************************************************
; Zhler -> ZV1
;***************************************************

	BTFSS S3,1	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,0
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC S1,6	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCF ZV1,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV1,F

LABEL_ZV1_SETOUT

; Output Q2

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS ZV1,2
	GOTO LABEL_ZV1_SETOUT2
	BSF S1,5
	GOTO LABEL_ZV1_SETOUT2_END
LABEL_ZV1_SETOUT2
	BCF S1,5
LABEL_ZV1_SETOUT2_END

; Output Q3

	BTFSS ZV1,3
	GOTO LABEL_ZV1_SETOUT3
	BSF S1,4
	GOTO LABEL_ZV1_SETOUT3_END
LABEL_ZV1_SETOUT3
	BCF S1,4
LABEL_ZV1_SETOUT3_END

; Output Q4

	BTFSS ZV1,4
	GOTO LABEL_ZV1_SETOUT4
	BSF S1,3
	GOTO LABEL_ZV1_SETOUT4_END
LABEL_ZV1_SETOUT4
	BCF S1,3
LABEL_ZV1_SETOUT4_END

; Output Q5

	BTFSS ZV1,5
	GOTO LABEL_ZV1_SETOUT5
	BSF S1,2
	GOTO LABEL_ZV1_SETOUT5_END
LABEL_ZV1_SETOUT5
	BCF S1,2
LABEL_ZV1_SETOUT5_END


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S0,0
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************
; UND - Gatter -> LG8
;***************************************************

LABEL_LG8_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,0
	GOTO LABEL_LG8_FALSE
LABEL_LG8_2
	BTFSS S1,7
	GOTO LABEL_LG8_FALSE

LABEL_LG8_TRUE
	BSF S1,6
	GOTO LABEL_LG8_ENDE
LABEL_LG8_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,6
LABEL_LG8_ENDE
;***************************************************
; VCC
;***************************************************

	BSF S1,7	; immer High

;***************************************************
; UND - Gatter -> LG9
;***************************************************

LABEL_LG9_1
	BTFSS S1,6
	GOTO LABEL_LG9_FALSE
LABEL_LG9_2
	BTFSS S2,0
	GOTO LABEL_LG9_FALSE

LABEL_LG9_TRUE
	BCF S0,4
	GOTO LABEL_LG9_ENDE
LABEL_LG9_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S0,4
LABEL_LG9_ENDE
;***************************************************
; VCC
;***************************************************

	BSF S2,0	; immer High

;***************************************************
; Zhler -> ZR1
;***************************************************

	BTFSS S2,1	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S5,5
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BSF S1,0
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF S1,0
LABEL_ZR1_SETOUT0_END

; Output Q1

	BTFSS ZR1,1
	GOTO LABEL_ZR1_SETOUT1
	BSF S6,3
	GOTO LABEL_ZR1_SETOUT1_END
LABEL_ZR1_SETOUT1
	BCF S6,3
LABEL_ZR1_SETOUT1_END

LABEL_ZR1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,5
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; One Shot -> OS3
;***************************************************


	BTFSC PORTA,4
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S5,6
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,6
	BTFSS PORTA,4
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************
; Zhler -> ZV2
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S2,7	; Reset ?
	GOTO LABEL_ZV2_COUNT
	CLRF ZV2
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,0
	GOTO LABEL_ZV2_SETFD
	BTFSC ZV2_FD,0
	GOTO LABEL_ZV2_SETFD

	BSF ZV2_FD,0


	BTFSC S1,6	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV2_BACKWARD

	INCF ZV2,F
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV2,F

LABEL_ZV2_SETOUT

; Output Q2

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS ZV2,2
	GOTO LABEL_ZV2_SETOUT2
	BSF S2,5
	GOTO LABEL_ZV2_SETOUT2_END
LABEL_ZV2_SETOUT2
	BCF S2,5
LABEL_ZV2_SETOUT2_END

; Output Q3

	BTFSS ZV2,3
	GOTO LABEL_ZV2_SETOUT3
	BSF S2,4
	GOTO LABEL_ZV2_SETOUT3_END
LABEL_ZV2_SETOUT3
	BCF S2,4
LABEL_ZV2_SETOUT3_END

; Output Q4

	BTFSS ZV2,4
	GOTO LABEL_ZV2_SETOUT4
	BSF S2,3
	GOTO LABEL_ZV2_SETOUT4_END
LABEL_ZV2_SETOUT4
	BCF S2,3
LABEL_ZV2_SETOUT4_END

; Output Q5

	BTFSS ZV2,5
	GOTO LABEL_ZV2_SETOUT5
	BSF S2,2
	GOTO LABEL_ZV2_SETOUT5_END
LABEL_ZV2_SETOUT5
	BCF S2,2
LABEL_ZV2_SETOUT5_END


LABEL_ZV2_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,0
	GOTO LABEL_ZV2_EXIT
	BCF ZV2_FD,0

LABEL_ZV2_EXIT

;***************************************************
; Call subroutine MP
;***************************************************


	MOVLW LOW MP
	MOVWF SYS_TMP1
	MOVLW HIGH MP
	MOVWF SYS_TMP2

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV1
	ADDWF SYS_TMP1,F
	BTFSC STATUS,CARRY
	INCF SYS_TMP2,F

	CALL SYSTABJMP

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF ZV1

	BSF INTCON,GIE
;***************************************************
; UND - Gatter -> LG10
;***************************************************

LABEL_LG10_1
	BTFSS S0,5
	GOTO LABEL_LG10_FALSE
LABEL_LG10_2
	BTFSS S0,4
	GOTO LABEL_LG10_FALSE

LABEL_LG10_TRUE
	BSF S4,7
	GOTO LABEL_LG10_ENDE
LABEL_LG10_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,7
LABEL_LG10_ENDE
;***************************************************
; Call subroutine MP
;***************************************************


	MOVLW LOW MP
	MOVWF SYS_TMP1
	MOVLW HIGH MP
	MOVWF SYS_TMP2

	MOVFW ZV2
	ADDWF SYS_TMP1,F
	BTFSC STATUS,CARRY
	INCF SYS_TMP2,F

	CALL SYSTABJMP

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF ZV2

	BSF INTCON,GIE
;***************************************************
; UND - Gatter -> LG11
;***************************************************

LABEL_LG11_1
	BTFSS S0,4
	GOTO LABEL_LG11_FALSE
LABEL_LG11_2
	BTFSS S2,6
	GOTO LABEL_LG11_FALSE

LABEL_LG11_TRUE
	BSF S4,3
	GOTO LABEL_LG11_ENDE
LABEL_LG11_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,3
LABEL_LG11_ENDE
;***************************************************
; UND - Gatter -> LG12
;***************************************************

LABEL_LG12_1
	BTFSS S3,2
	GOTO LABEL_LG12_FALSE
LABEL_LG12_2
	BTFSS S3,3
	GOTO LABEL_LG12_FALSE
LABEL_LG12_3
	BTFSS S3,4
	GOTO LABEL_LG12_FALSE
LABEL_LG12_4
	BTFSS S3,5
	GOTO LABEL_LG12_FALSE

LABEL_LG12_TRUE
	BSF S4,2
	GOTO LABEL_LG12_ENDE
LABEL_LG12_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,2
LABEL_LG12_ENDE
;***************************************************
; Zhler -> ZV3
;***************************************************

	BTFSS S4,5	; Reset ?
	GOTO LABEL_ZV3_COUNT
	CLRF ZV3
	GOTO LABEL_ZV3_SETOUT

LABEL_ZV3_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S4,0
	GOTO LABEL_ZV3_SETFD
	BTFSC ZV3_FD,0
	GOTO LABEL_ZV3_SETFD

	BSF ZV3_FD,0


	BTFSC S1,6	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV3_BACKWARD

	INCF ZV3,F
	GOTO LABEL_ZV3_SETOUT

LABEL_ZV3_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV3,F

LABEL_ZV3_SETOUT

; Output Q2

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS ZV3,2
	GOTO LABEL_ZV3_SETOUT2
	BSF S3,2
	GOTO LABEL_ZV3_SETOUT2_END
LABEL_ZV3_SETOUT2
	BCF S3,2
LABEL_ZV3_SETOUT2_END

; Output Q3

	BTFSS ZV3,3
	GOTO LABEL_ZV3_SETOUT3
	BSF S3,3
	GOTO LABEL_ZV3_SETOUT3_END
LABEL_ZV3_SETOUT3
	BCF S3,3
LABEL_ZV3_SETOUT3_END

; Output Q4

	BTFSS ZV3,4
	GOTO LABEL_ZV3_SETOUT4
	BSF S3,4
	GOTO LABEL_ZV3_SETOUT4_END
LABEL_ZV3_SETOUT4
	BCF S3,4
LABEL_ZV3_SETOUT4_END

; Output Q5

	BTFSS ZV3,5
	GOTO LABEL_ZV3_SETOUT5
	BSF S3,5
	GOTO LABEL_ZV3_SETOUT5_END
LABEL_ZV3_SETOUT5
	BCF S3,5
LABEL_ZV3_SETOUT5_END


LABEL_ZV3_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S4,0
	GOTO LABEL_ZV3_EXIT
	BCF ZV3_FD,0

LABEL_ZV3_EXIT

;***************************************************
; UND - Gatter -> LG13
;***************************************************

LABEL_LG13_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,4
	GOTO LABEL_LG13_FALSE
LABEL_LG13_2
	BTFSS S3,6
	GOTO LABEL_LG13_FALSE

LABEL_LG13_TRUE
	BSF S3,7
	GOTO LABEL_LG13_ENDE
LABEL_LG13_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,7
LABEL_LG13_ENDE
;***************************************************
; ODER - Gatter -> LG14
;***************************************************

LABEL_LG14_1
	BTFSC S3,7
	GOTO LABEL_LG14_TRUE
LABEL_LG14_2
	BTFSC S2,6
	GOTO LABEL_LG14_TRUE

LABEL_LG14_FALSE
	BCF S4,0
	GOTO LABEL_LG14_ENDE
LABEL_LG14_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S4,0
LABEL_LG14_ENDE
;***************************************************
; UND - Gatter -> LG15
;***************************************************

LABEL_LG15_1
	BTFSS S4,2
	GOTO LABEL_LG15_FALSE
LABEL_LG15_2
	BTFSS S0,4
	GOTO LABEL_LG15_FALSE

LABEL_LG15_TRUE
	BSF S4,1
	GOTO LABEL_LG15_ENDE
LABEL_LG15_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,1
LABEL_LG15_ENDE
;***************************************************
; One Shot -> OS4
;***************************************************


	BTFSC PORTA,0
	GOTO LABEL_OS4_1
	BTFSC OS4_FD,0
	GOTO LABEL_OS4_1
	BSF OS4_FD,0
	BSF S3,6
	GOTO LABEL_OS4_2
LABEL_OS4_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,6
	BTFSS PORTA,0
	GOTO LABEL_OS4_2
	BCF OS4_FD,0
LABEL_OS4_2
;***************************************************
; One Shot -> OS5
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTA,3
	GOTO LABEL_OS5_1
	BTFSC OS5_FD,0
	GOTO LABEL_OS5_1
	BSF OS5_FD,0
	BSF S5,0
	GOTO LABEL_OS5_2
LABEL_OS5_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,0
	BTFSS PORTA,3
	GOTO LABEL_OS5_2
	BCF OS5_FD,0
LABEL_OS5_2
;***************************************************
; ODER - Gatter -> LG16
;***************************************************

LABEL_LG16_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S4,3
	GOTO LABEL_LG16_TRUE
LABEL_LG16_2
	BTFSC S4,4
	GOTO LABEL_LG16_TRUE

LABEL_LG16_FALSE
	BCF S2,7
	GOTO LABEL_LG16_ENDE
LABEL_LG16_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S2,7
LABEL_LG16_ENDE
;***************************************************
; ODER - Gatter -> LG17
;***************************************************

LABEL_LG17_1
	BTFSC S4,4
	GOTO LABEL_LG17_TRUE
LABEL_LG17_2
	BTFSC S4,1
	GOTO LABEL_LG17_TRUE

LABEL_LG17_FALSE
	BCF S4,5
	GOTO LABEL_LG17_ENDE
LABEL_LG17_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S4,5
LABEL_LG17_ENDE
;***************************************************
; ODER - Gatter -> LG18
;***************************************************

LABEL_LG18_1
	BTFSC S4,7
	GOTO LABEL_LG18_TRUE
LABEL_LG18_2
	BTFSC S4,4
	GOTO LABEL_LG18_TRUE

LABEL_LG18_FALSE
	BCF S3,1
	GOTO LABEL_LG18_ENDE
LABEL_LG18_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S3,1
LABEL_LG18_ENDE
;***************************************************
; UND - Gatter -> LG19
;***************************************************

LABEL_LG19_1
	BTFSC S1,6
	GOTO LABEL_LG19_FALSE
LABEL_LG19_2
	BTFSS S5,0
	GOTO LABEL_LG19_FALSE

LABEL_LG19_TRUE
	BSF S4,4
	GOTO LABEL_LG19_ENDE
LABEL_LG19_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,4
LABEL_LG19_ENDE
;***************************************************
; LCD -> LT1
;***************************************************

; test of positiv edge

	BTFSC LT1_FD,0
	GOTO LABEL_LT1_SETFD
	BTFSS S5,1
	GOTO LABEL_LT1_SETFD


	MOVLW 3
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV3
	MOVWF SYS_TMP4
	CLRF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 2
	MOVWF SYS_TMP9
	CALL LCD_LB1_DEZO100
LABEL_LT1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT1_SETFD2
	BSF LT1_FD,0
	GOTO LABEL_LT1_END
LABEL_LT1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT1_FD,0
LABEL_LT1_END

;***************************************************
; LCD -> LT2
;***************************************************

; test of positiv edge

	BTFSC LT2_FD,0
	GOTO LABEL_LT2_SETFD
	BTFSS S5,1
	GOTO LABEL_LT2_SETFD


	MOVLW 5
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV1
	MOVWF SYS_TMP4
	CLRF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 2
	MOVWF SYS_TMP9
	CALL LCD_LB1_DEZO100
LABEL_LT2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT2_SETFD2
	BSF LT2_FD,0
	GOTO LABEL_LT2_END
LABEL_LT2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT2_FD,0
LABEL_LT2_END

;***************************************************
; LCD -> LT3
;***************************************************

; test of positiv edge

	BTFSC LT3_FD,0
	GOTO LABEL_LT3_SETFD
	BTFSS S5,1
	GOTO LABEL_LT3_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV2
	MOVWF SYS_TMP4
	CLRF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 2
	MOVWF SYS_TMP9
	CALL LCD_LB1_DEZO100
LABEL_LT3_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT3_SETFD2
	BSF LT3_FD,0
	GOTO LABEL_LT3_END
LABEL_LT3_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT3_FD,0
LABEL_LT3_END

;***************************************************
; LCD -> LT4
;***************************************************

; test of positiv edge

	BTFSC LT4_FD,0
	GOTO LABEL_LT4_SETFD
	BTFSS S5,1
	GOTO LABEL_LT4_SETFD


	MOVLW 5
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT4
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT4
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT4_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT4_SETFD2
	BSF LT4_FD,0
	GOTO LABEL_LT4_END
LABEL_LT4_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT4_FD,0
LABEL_LT4_END

;***************************************************
; LCD -> LT5
;***************************************************

; test of positiv edge

	BTFSC LT5_FD,0
	GOTO LABEL_LT5_SETFD
	BTFSS S5,1
	GOTO LABEL_LT5_SETFD


	MOVLW 2
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT5
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT5
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT5_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT5_SETFD2
	BSF LT5_FD,0
	GOTO LABEL_LT5_END
LABEL_LT5_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT5_FD,0
LABEL_LT5_END

;***************************************************
; LCD -> LT6
;***************************************************

; test of positiv edge

	BTFSC LT6_FD,0
	GOTO LABEL_LT6_SETFD
	BTFSS S5,1
	GOTO LABEL_LT6_SETFD


	MOVLW 1
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT6
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT6
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT6_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT6_SETFD2
	BSF LT6_FD,0
	GOTO LABEL_LT6_END
LABEL_LT6_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT6_FD,0
LABEL_LT6_END

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 8
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 8
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S6,5
	GOTO LABEL_TR1_CLR
	BSF S6,5
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S6,5
LABEL_TR1_ENDE

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 0
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF ZV1,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,CARRY	; Test auf -> >
	GOTO LABEL_IF1_FALSE
	BTFSC STATUS,ZERO
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S5,3
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S5,3

LABEL_IF1_EXIT
;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 0
	SUBWF ZV2,W	; F - W -> W

LABEL_IF2_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,CARRY	; Test auf -> >
	GOTO LABEL_IF2_FALSE
	BTFSC STATUS,ZERO
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S5,2
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S5,2

LABEL_IF2_EXIT
;***************************************************
; Vergleich -> IF3
;***************************************************

	MOVLW 0
	SUBWF ZV3,W	; F - W -> W

LABEL_IF3_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,CARRY	; Test auf -> >
	GOTO LABEL_IF3_FALSE
	BTFSC STATUS,ZERO
	GOTO LABEL_IF3_FALSE

LABEL_IF3_TRUE
	BSF S5,4
	GOTO LABEL_IF3_EXIT

LABEL_IF3_FALSE
	BCF S5,4

LABEL_IF3_EXIT
;***************************************************
; ODER - Gatter -> LG20
;***************************************************

LABEL_LG20_1
	BTFSC S5,3
	GOTO LABEL_LG20_TRUE
LABEL_LG20_2
	BTFSC S5,2
	GOTO LABEL_LG20_TRUE
LABEL_LG20_3
	BTFSC S5,4
	GOTO LABEL_LG20_TRUE

LABEL_LG20_FALSE
	BCF S5,7
	GOTO LABEL_LG20_ENDE
LABEL_LG20_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S5,7
LABEL_LG20_ENDE
;***************************************************
; UND - Gatter -> LG21
;***************************************************

LABEL_LG21_1
	BTFSS S5,6
	GOTO LABEL_LG21_FALSE
LABEL_LG21_2
	BTFSS S5,7
	GOTO LABEL_LG21_FALSE

LABEL_LG21_TRUE
	BSF S5,5
	GOTO LABEL_LG21_ENDE
LABEL_LG21_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,5
LABEL_LG21_ENDE
;***************************************************
; Vergleich -> IF4
;***************************************************

	MOVLW 0
	SUBWF ZV1,W	; F - W -> W

LABEL_IF4_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF4_FALSE

LABEL_IF4_TRUE
	BSF S6,1
	GOTO LABEL_IF4_EXIT

LABEL_IF4_FALSE
	BCF S6,1

LABEL_IF4_EXIT
;***************************************************
; Vergleich -> IF5
;***************************************************

	MOVLW 0
	SUBWF ZV2,W	; F - W -> W

LABEL_IF5_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF5_FALSE

LABEL_IF5_TRUE
	BSF S6,0
	GOTO LABEL_IF5_EXIT

LABEL_IF5_FALSE
	BCF S6,0

LABEL_IF5_EXIT
;***************************************************
; Vergleich -> IF6
;***************************************************

	MOVLW 0
	SUBWF ZV3,W	; F - W -> W

LABEL_IF6_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF6_FALSE

LABEL_IF6_TRUE
	BSF S6,2
	GOTO LABEL_IF6_EXIT

LABEL_IF6_FALSE
	BCF S6,2

LABEL_IF6_EXIT
;***************************************************
; UND - Gatter -> LG22
;***************************************************

LABEL_LG22_1
	BTFSS S6,1
	GOTO LABEL_LG22_FALSE
LABEL_LG22_2
	BTFSS S6,0
	GOTO LABEL_LG22_FALSE
LABEL_LG22_3
	BTFSS S6,2
	GOTO LABEL_LG22_FALSE

LABEL_LG22_TRUE
	BSF S6,4
	GOTO LABEL_LG22_ENDE
LABEL_LG22_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S6,4
LABEL_LG22_ENDE
;***************************************************
; ODER - Gatter -> LG23
;***************************************************

LABEL_LG23_1
	BTFSC S6,3
	GOTO LABEL_LG23_TRUE
LABEL_LG23_2
	BTFSC S6,4
	GOTO LABEL_LG23_TRUE

LABEL_LG23_FALSE
	BCF S2,1
	GOTO LABEL_LG23_ENDE
LABEL_LG23_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S2,1
LABEL_LG23_ENDE
;***************************************************
; LCD -> LT7
;***************************************************

; test of positiv edge

	BTFSC LT7_FD,0
	GOTO LABEL_LT7_SETFD
	BTFSS S6,4
	GOTO LABEL_LT7_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT7
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT7
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT7_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S6,4
	GOTO LABEL_LT7_SETFD2
	BSF LT7_FD,0
	GOTO LABEL_LT7_END
LABEL_LT7_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT7_FD,0
LABEL_LT7_END

;***************************************************
; UND - Gatter -> LG24
;***************************************************

LABEL_LG24_1
	BTFSS S6,5
	GOTO LABEL_LG24_FALSE
LABEL_LG24_2
	BTFSS S5,7
	GOTO LABEL_LG24_FALSE

LABEL_LG24_TRUE
	BSF S5,1
	GOTO LABEL_LG24_ENDE
LABEL_LG24_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,1
LABEL_LG24_ENDE
;***************************************************
; UND - Gatter -> LG25
;***************************************************

LABEL_LG25_1
	BTFSS S1,0
	GOTO LABEL_LG25_FALSE
LABEL_LG25_2
	BTFSS S1,0
	GOTO LABEL_LG25_FALSE

LABEL_LG25_TRUE
	BSF PORTB,6
	GOTO LABEL_LG25_ENDE
LABEL_LG25_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,6
LABEL_LG25_ENDE
;***************************************************
; Mono-Flop -> MF1
;***************************************************

; Luft der Impuls ?

	BTFSC MF1_FD,1
	GOTO LABEL_MF1_CHKTIME

; Test auf positive Flanke

	BTFSC MF1_FD,0
	GOTO LABEL_MF1_SETFD
	BTFSS S6,4
	GOTO LABEL_MF1_SETFD


LABEL_MF1_RESET

	CLRF MF1
	CLRF MF1_HI
	BSF MF1_FD,1
	BSF S6,6

LABEL_MF1_CHKTIME

	MOVLW 61
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF MF1_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MF1_CHECK
	MOVLW 9
	SUBWF MF1,W
LABEL_MF1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_SETFD
LABEL_MF1_TO

	BCF MF1_FD,1
	BCF S6,6

LABEL_MF1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S6,4
	GOTO LABEL_MF1_CLR
	BSF MF1_FD,0
	GOTO LABEL_MF1_ENDE
LABEL_MF1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF MF1_FD,0

LABEL_MF1_ENDE

;***************************************************
; UND - Gatter -> LG26
;***************************************************

LABEL_LG26_1
	BTFSS S6,5
	GOTO LABEL_LG26_FALSE
LABEL_LG26_2
	BTFSS S6,6
	GOTO LABEL_LG26_FALSE
LABEL_LG26_3
	BTFSS S0,7
	GOTO LABEL_LG26_FALSE

LABEL_LG26_TRUE
	BSF PORTB,7
	GOTO LABEL_LG26_ENDE
LABEL_LG26_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,7
LABEL_LG26_ENDE
;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 161
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S0,7
	GOTO LABEL_TR2_CLR
	BSF S0,7
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S0,7
LABEL_TR2_ENDE

;****************************************

	GOTO MAIN

;***************************************************
; Table -> MP
;***************************************************

MP

	RETLW 0	; // INDEX 0
	RETLW 1	; // INDEX 1
	RETLW 2	; // INDEX 2
	RETLW 3	; // INDEX 3
	RETLW 4	; // INDEX 4
	RETLW 5	; // INDEX 5
	RETLW 6	; // INDEX 6
	RETLW 7	; // INDEX 7
	RETLW 8	; // INDEX 8
	RETLW 9	; // INDEX 9
	RETLW 10	; // INDEX 10
	RETLW 11	; // INDEX 11
	RETLW 12	; // INDEX 12
	RETLW 13	; // INDEX 13
	RETLW 14	; // INDEX 14
	RETLW 15	; // INDEX 15
	RETLW 16	; // INDEX 16
	RETLW 17	; // INDEX 17
	RETLW 18	; // INDEX 18
	RETLW 19	; // INDEX 19
	RETLW 20	; // INDEX 20
	RETLW 21	; // INDEX 21
	RETLW 22	; // INDEX 22
	RETLW 23	; // INDEX 23
	RETLW 24	; // INDEX 24
	RETLW 25	; // INDEX 25
	RETLW 26	; // INDEX 26
	RETLW 27	; // INDEX 27
	RETLW 28	; // INDEX 28
	RETLW 29	; // INDEX 29
	RETLW 30	; // INDEX 30
	RETLW 31	; // INDEX 31
	RETLW 32	; // INDEX 32
	RETLW 33	; // INDEX 33
	RETLW 34	; // INDEX 34
	RETLW 35	; // INDEX 35
	RETLW 36	; // INDEX 36
	RETLW 37	; // INDEX 37
	RETLW 38	; // INDEX 38
	RETLW 39	; // INDEX 39
	RETLW 40	; // INDEX 40
	RETLW 41	; // INDEX 41
	RETLW 42	; // INDEX 42
	RETLW 43	; // INDEX 43
	RETLW 44	; // INDEX 44
	RETLW 45	; // INDEX 45
	RETLW 46	; // INDEX 46
	RETLW 47	; // INDEX 47
	RETLW 48	; // INDEX 48
	RETLW 49	; // INDEX 49
	RETLW 50	; // INDEX 50
	RETLW 51	; // INDEX 51
	RETLW 52	; // INDEX 52
	RETLW 53	; // INDEX 53
	RETLW 54	; // INDEX 54
	RETLW 55	; // INDEX 55
	RETLW 56	; // INDEX 56
	RETLW 57	; // INDEX 57
	RETLW 58	; // INDEX 58
	RETLW 59	; // INDEX 59
	RETLW 60	; // INDEX 60
	RETLW 61	; // INDEX 61
	RETLW 62	; // INDEX 62
	RETLW 63	; // INDEX 63
	RETLW 64	; // INDEX 64
	RETLW 65	; // INDEX 65
	RETLW 66	; // INDEX 66
	RETLW 67	; // INDEX 67
	RETLW 68	; // INDEX 68
	RETLW 69	; // INDEX 69
	RETLW 70	; // INDEX 70
	RETLW 71	; // INDEX 71
	RETLW 72	; // INDEX 72
	RETLW 73	; // INDEX 73
	RETLW 74	; // INDEX 74
	RETLW 75	; // INDEX 75
	RETLW 76	; // INDEX 76
	RETLW 77	; // INDEX 77
	RETLW 78	; // INDEX 78
	RETLW 79	; // INDEX 79
	RETLW 80	; // INDEX 80
	RETLW 81	; // INDEX 81
	RETLW 82	; // INDEX 82
	RETLW 83	; // INDEX 83
	RETLW 84	; // INDEX 84
	RETLW 85	; // INDEX 85
	RETLW 86	; // INDEX 86
	RETLW 87	; // INDEX 87
	RETLW 88	; // INDEX 88
	RETLW 89	; // INDEX 89
	RETLW 90	; // INDEX 90
	RETLW 91	; // INDEX 91
	RETLW 92	; // INDEX 92
	RETLW 93	; // INDEX 93
	RETLW 94	; // INDEX 94
	RETLW 95	; // INDEX 95
	RETLW 96	; // INDEX 96
	RETLW 97	; // INDEX 97
	RETLW 98	; // INDEX 98
	RETLW 99	; // INDEX 99
	RETLW 100	; // INDEX 100
	RETLW 101	; // INDEX 101
	RETLW 102	; // INDEX 102
	RETLW 103	; // INDEX 103
	RETLW 104	; // INDEX 104
	RETLW 105	; // INDEX 105
	RETLW 106	; // INDEX 106
	RETLW 107	; // INDEX 107
	RETLW 108	; // INDEX 108
	RETLW 109	; // INDEX 109
	RETLW 110	; // INDEX 110
	RETLW 111	; // INDEX 111
	RETLW 112	; // INDEX 112
	RETLW 113	; // INDEX 113
	RETLW 114	; // INDEX 114
	RETLW 115	; // INDEX 115
	RETLW 116	; // INDEX 116
	RETLW 117	; // INDEX 117
	RETLW 118	; // INDEX 118
	RETLW 119	; // INDEX 119
	RETLW 120	; // INDEX 120
	RETLW 121	; // INDEX 121
	RETLW 122	; // INDEX 122
	RETLW 123	; // INDEX 123
	RETLW 124	; // INDEX 124
	RETLW 125	; // INDEX 125
	RETLW 126	; // INDEX 126
	RETLW 127	; // INDEX 127
	RETLW 128	; // INDEX 128
	RETLW 129	; // INDEX 129
	RETLW 130	; // INDEX 130
	RETLW 131	; // INDEX 131
	RETLW 132	; // INDEX 132
	RETLW 133	; // INDEX 133
	RETLW 134	; // INDEX 134
	RETLW 135	; // INDEX 135
	RETLW 136	; // INDEX 136
	RETLW 137	; // INDEX 137
	RETLW 138	; // INDEX 138
	RETLW 139	; // INDEX 139
	RETLW 140	; // INDEX 140
	RETLW 141	; // INDEX 141
	RETLW 142	; // INDEX 142
	RETLW 143	; // INDEX 143
	RETLW 144	; // INDEX 144
	RETLW 145	; // INDEX 145
	RETLW 146	; // INDEX 146
	RETLW 147	; // INDEX 147
	RETLW 148	; // INDEX 148
	RETLW 149	; // INDEX 149
	RETLW 150	; // INDEX 150
	RETLW 151	; // INDEX 151
	RETLW 152	; // INDEX 152
	RETLW 153	; // INDEX 153
	RETLW 154	; // INDEX 154
	RETLW 155	; // INDEX 155
	RETLW 156	; // INDEX 156
	RETLW 157	; // INDEX 157
	RETLW 158	; // INDEX 158
	RETLW 159	; // INDEX 159
	RETLW 160	; // INDEX 160
	RETLW 161	; // INDEX 161
	RETLW 162	; // INDEX 162
	RETLW 163	; // INDEX 163
	RETLW 164	; // INDEX 164
	RETLW 165	; // INDEX 165
	RETLW 166	; // INDEX 166
	RETLW 167	; // INDEX 167
	RETLW 168	; // INDEX 168
	RETLW 169	; // INDEX 169
	RETLW 170	; // INDEX 170
	RETLW 171	; // INDEX 171
	RETLW 172	; // INDEX 172
	RETLW 173	; // INDEX 173
	RETLW 174	; // INDEX 174
	RETLW 175	; // INDEX 175
	RETLW 176	; // INDEX 176
	RETLW 177	; // INDEX 177
	RETLW 178	; // INDEX 178
	RETLW 179	; // INDEX 179
	RETLW 180	; // INDEX 180
	RETLW 181	; // INDEX 181
	RETLW 182	; // INDEX 182
	RETLW 183	; // INDEX 183
	RETLW 184	; // INDEX 184
	RETLW 185	; // INDEX 185
	RETLW 186	; // INDEX 186
	RETLW 187	; // INDEX 187
	RETLW 188	; // INDEX 188
	RETLW 189	; // INDEX 189
	RETLW 190	; // INDEX 190
	RETLW 191	; // INDEX 191
	RETLW 192	; // INDEX 192
	RETLW 193	; // INDEX 193
	RETLW 194	; // INDEX 194
	RETLW 195	; // INDEX 195
	RETLW 196	; // INDEX 196
	RETLW 197	; // INDEX 197
	RETLW 198	; // INDEX 198
	RETLW 199	; // INDEX 199
	RETLW 200	; // INDEX 200
	RETLW 201	; // INDEX 201
	RETLW 202	; // INDEX 202
	RETLW 203	; // INDEX 203
	RETLW 204	; // INDEX 204
	RETLW 205	; // INDEX 205
	RETLW 206	; // INDEX 206
	RETLW 207	; // INDEX 207
	RETLW 208	; // INDEX 208
	RETLW 209	; // INDEX 209
	RETLW 210	; // INDEX 210
	RETLW 211	; // INDEX 211
	RETLW 212	; // INDEX 212
	RETLW 213	; // INDEX 213
	RETLW 214	; // INDEX 214
	RETLW 215	; // INDEX 215
	RETLW 216	; // INDEX 216
	RETLW 217	; // INDEX 217
	RETLW 218	; // INDEX 218
	RETLW 219	; // INDEX 219
	RETLW 220	; // INDEX 220
	RETLW 221	; // INDEX 221
	RETLW 222	; // INDEX 222
	RETLW 223	; // INDEX 223
	RETLW 224	; // INDEX 224
	RETLW 225	; // INDEX 225
	RETLW 226	; // INDEX 226
	RETLW 227	; // INDEX 227
	RETLW 228	; // INDEX 228
	RETLW 229	; // INDEX 229
	RETLW 230	; // INDEX 230
	RETLW 231	; // INDEX 231
	RETLW 232	; // INDEX 232
	RETLW 233	; // INDEX 233
	RETLW 234	; // INDEX 234
	RETLW 235	; // INDEX 235
	RETLW 236	; // INDEX 236
	RETLW 237	; // INDEX 237
	RETLW 238	; // INDEX 238
	RETLW 239	; // INDEX 239
	RETLW 240	; // INDEX 240
	RETLW 241	; // INDEX 241
	RETLW 242	; // INDEX 242
	RETLW 243	; // INDEX 243
	RETLW 244	; // INDEX 244
	RETLW 245	; // INDEX 245
	RETLW 246	; // INDEX 246
	RETLW 247	; // INDEX 247
	RETLW 248	; // INDEX 248
	RETLW 249	; // INDEX 249
	RETLW 250	; // INDEX 250
	RETLW 251	; // INDEX 251
	RETLW 252	; // INDEX 252
	RETLW 253	; // INDEX 253
	RETLW 254	; // INDEX 254
	RETLW 59	; // INDEX 255








TAB_LT4
	RETLW 32	;  
	RETLW 109	; m
	RETLW 32	;  
	RETLW 0	; end


TAB_LT5
	RETLW 32	;  
	RETLW 115	; s
	RETLW 32	;  
	RETLW 0	; end


TAB_LT6
	RETLW 72	; H
	RETLW 32	;  
	RETLW 0	; end


TAB_LT7
	RETLW 32	;  
	RETLW 42	; *
	RETLW 42	; *
	RETLW 42	; *
	RETLW 32	;  
	RETLW 32	;  
	RETLW 69	; E
	RETLW 78	; N
	RETLW 68	; D
	RETLW 33	; !
	RETLW 32	;  
	RETLW 32	;  
	RETLW 42	; *
	RETLW 42	; *
	RETLW 42	; *
	RETLW 32	;  
	RETLW 0	; end


	END

